% steplfm_cal.m - stepped train of LFM pulses calculation
% written by Eli mozeson and Nadav Levanon
% used with steplfm_gui.m

mm=200;
mm2=mm/2-1;
ufm=ones(1,mm);

ddf=tpb/mm^2;
ffm=ddf*(-mm2:mm2+1)-ddf/2;
mtr=round((trovertp-1)*mm);

space1=zeros(1,mtr);
u_step1=[ufm space1];
f_step1=[ffm space1];
f1=-(nn-1)/2;
u_step=u_step1;
f_step=f_step1;
f_add=[f1*u_step1];


if cost ==1;
    if nn==16
        qq=[6 14 2 3 10 8 11 15 9 1 13 12 5 7 4] ;
        % qq= [2 8 9 12 4 14 10 15 13 7 6 3 11 1 5]
        % qq= [13 8 6 12 11 14 5 15 2 7 9 3 4 1 10]  
    elseif nn==8
            qq=[7 2 5 1 6 4 3];
    elseif nn==4
                qq=[2 3 1];
    elseif nn==3
                qq=[2 1];
    end
end
if cost==0  % linear steps
    if nn==16
        qq=[1:15] ;
    elseif nn==8
            qq=[1:7];
    elseif nn==4
                qq=[1:3];
    else
                qq=[1:nn-1];
    end
end
                        
for q= qq
            u_step=[u_step u_step1];
            f_step=[f_step (rv)^q*f_step1];
            f_add=[f_add  (f1+q)*u_step1];
end
f_total=f_step+(tpdf/mm)*f_add;
u_amp = u_step;
f_basic = f_total;
u_phase = zeros(size(u_step));

acode=1;
pcode=0;
fcode=1;
